import data,re
from problem import *
import generator

def test(rgx,qst):
  res = qst.get_result(rgx)
  if res.regex_error:
    print 'Oops, regex error!'
    return False
  if qst.problemtype == problem.EASY_LIST:
    print 'You matched %d of the %d correct words: %s' % \
      (res.good_match, len(qst.goodwords), ' '.join(res.matched_good()))
    print 'You matched %d of the %d wrong words: %s' % \
      (res.bad_match, len(qst.badwords), ' '.join(res.matched_bad()))
  if res.success:
    print 'Congratulations, "%s" is a correct regex for this problem' % (rgx)
    raw_input('Press Enter To Continue>')
    return True
  return False

def run():
  problems = load_tutorial()
  # test code, mainly
  generated_problems = []
  for i in range(10):
    generated_problems.append(generator.generate_problem(i+1))
  for qst in generated_problems:
    print qst.title + ':'
    print qst.explanation
    print 'These are the words to match:'
    for wrd in qst.goodwords:
      print wrd
    print 'These are the words you must not match:'
    for wrd in qst.badwords:
      print wrd
    print 'Now, give me a regex that matches the first group of words and not the second.'
    while True:
      inp = raw_input('regex>')
      if test(inp,qst):
        break
    print 'Goodbye!'

def load_tutorial():
  questions = []
  problems = []
  exec(data.load('tutorial.dat'))
  for qst in questions:
    q = problem()
    q.from_tuple(qst)
    problems.append(q)
  return problems

      
